package ipm.ipmworks.model;

import lombok.Getter;
import lombok.Setter;
import org.springframework.data.annotation.Id;
import org.springframework.data.annotation.Transient;
import org.springframework.data.mongodb.core.mapping.Document;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Document(collection="Resource")
@Getter
@Setter

public class Resource {
    @Id
    private String idResource;
    private String resourceOrigin;
    private String resourceName;
    private String description;
    private String descriptionNative;
    private ResourceType resourceType;
    private String contactInstitution;
    private String contactName;
    private String contactEmail;
    private String contactPhone;
    private String contactAddress;

    private List<String> links = new ArrayList<String>();
    private List<Map> files = new ArrayList();
    private String project;
    private String projectWeb;
    private String projectGrantNo;
    private Language language;
    private List<Sector> sectors = new ArrayList<Sector>();
    private List<Region> regions = new ArrayList<Region>();
    private String citation;
    private String mainURL;
    private User approvedBy;
    private List<Pest> pests = new ArrayList<Pest>();
    private List<Crop> crops = new ArrayList<Crop>();
    private List<User> likes = new ArrayList<User>();
    private Date creationDate;
    private boolean approved;
    private boolean canEdit;
    private boolean external;
}
