package ipm.ipmworks.security;

import ipm.ipmworks.model.Role;
import ipm.ipmworks.model.User;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.userdetails.UserDetails;

import java.util.Collection;
import java.util.List;
import java.util.stream.Collectors;

public class IPMUserDetailsImpl implements UserDetails {

    String id;
    String username;
    String password;
    String name;
    Collection<? extends GrantedAuthority> authorities;
    List<String> roles;

    public IPMUserDetailsImpl(User user) {
        this.id = user.getIdUser();
        this.username = user.getUsername();
        this.password = user.getPassword();
        this.authorities = user.getAuthorities();
        this.name = user.getName();
        this.roles = this.authorities.stream().map(a -> a.getAuthority()).collect(Collectors.toList());
    }

    @Override
    public Collection<? extends GrantedAuthority> getAuthorities() {
        return authorities;
    }

    @Override
    public String getPassword() {
        return password;
    }

    @Override
    public String getUsername() {
        return username;
    }

    @Override
    public boolean isAccountNonExpired() {
        return true;
    }

    @Override
    public boolean isAccountNonLocked() {
        return true;
    }

    @Override
    public boolean isCredentialsNonExpired() {
        return true;
    }

    @Override
    public boolean isEnabled() {
        return true;
    }

    public String getName() {
        return name;
    }


    public String getID() {
        return id;
    }

    public List<String> getRoles() {
        return this.roles;
    }

    public void setName(String name) {
        this.name = name;
    }

}
